Index: c/src/lib/libbsp/powerpc/gen83xx/start/start.S
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/start/start.S	(revision 3c6fe2e7f95f6bff53123df9377b114cadeac874)
+++ c/src/lib/libbsp/powerpc/gen83xx/start/start.S	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -19,27 +19,8 @@
 /* $Id$ */   
 
-#include <rtems/asm.h> 
+#include <libcpu/powerpc-utility.h> 
 #include <rtems/powerpc/cache.h>
-#include <rtems/powerpc/registers.h>
+#include <bsp.h>
 #include <mpc83xx/mpc83xx.h>
-#include <bsp.h>
-
-/* Macro definitions to load a register with a 32-bit address.
-   Both functions identically.  Sometimes one mnemonic is more
-   appropriate than the other.
-   reg 		-> register to load
-   value 	-> value to be loaded
-   LA  reg,value    ("Load Address")
-   LWI reg,value    ("Load Word Immediate") */
-
-.macro LA reg, value
-	lis \reg , \value@h
-	ori \reg , \reg, \value@l
-.endm
-
-.macro LWI reg, value
-	lis \reg , (\value)@h
-	ori \reg , \reg, (\value)@l
-.endm 
 
 .macro SET_IMM_REGW base, reg2, offset, value
@@ -48,41 +29,8 @@
 .endm 
 
-/* Macro definitions to test, set or clear a single 
-   bit or bit pattern in a given 32bit GPR. 
-   reg1		-> register content to be tested
-   reg2		-> 2nd register only needed for computation
-   mask		-> any bit pattern */
-
-.macro	TSTBITS	reg1, reg2, reg3, mask	/* Match is indicated by EQ=0 (CR) */ 
-	LWI 	\reg3, \mask		/* Unmatch is indicated by EQ=1 (CR) */
-	and	\reg1, \reg1, \reg3
-	and	\reg2, \reg2, \reg3
-	cmplw	\reg1, \reg2
-	sync
-.endm	
-	
-.macro 	SETBITS reg1, reg2, mask
-	LWI 	\reg2, \mask
-	or	\reg1, \reg1, \reg2 
-	sync
-.endm
-
-.macro 	CLRBITS reg1, reg2, mask
-	LWI 	\reg2, \mask
-	andc	\reg1, \reg1, \reg2
-	sync
-.endm
-
 #define REP8(l) l ; l; l; l; l; l; l; l;
 
-.extern	_bss_start
-.extern	_bss_size
-.extern	_data_start
-.extern	_data_size
-.extern	_text_start
-.extern	_text_size
-/*.extern _s_got*/
 .extern boot_card
-.extern MBAR   
+.extern MBAR
 
 #if defined(RESET_CONF_WRD_L)
@@ -109,4 +57,30 @@
 PUBLIC_VAR (start)
 start:
+
+#ifdef HAS_UBOOT
+
+.extern mpc83xx_uboot_board_info
+.extern mpc83xx_uboot_board_info_size
+
+	/* Reset time base */
+	li	r0, 0
+	mtspr	TBWU, r0
+	mtspr	TBWL, r0
+
+	/* Copy board info */
+	LA	r6, mpc83xx_uboot_board_info
+	LW	r5, mpc83xx_uboot_board_info_size
+        mtctr   r5
+
+copy_uboot_board_info:
+
+	lwz     r5, 0(r3)
+        addi    r3, r3, 4
+        stw     r5, 0(r6)
+        addi    r6, r6, 4
+        bdnz    copy_uboot_board_info
+
+#endif /* HAS_UBOOT */
+
 	/*
 	 * basic CPU setup:	
@@ -117,4 +91,5 @@
 	CLRBITS r30, r29, MSR_IP|MSR_EE
 	mtmsr	r30 				/* Set RI/ME, Clr EE in MSR */
+
 	b start_rom_skip
 	
@@ -166,5 +141,5 @@
 	 * ROM startup: jump to code final ROM location
 	 */
-	LA	r20, ROM_START /* ROM-RAM reloc in r20 */
+	LA	r20, bsp_rom_start /* ROM-RAM reloc in r20 */
 	LA	r29, start_code_in_rom /* get compile time addr of label */
 	add	r29,r20,r29    /* compute exec address */
@@ -381,10 +356,10 @@
 	 */
 	/* get start address of text section in RAM */
-	LA	r29, _text_start  
+	LA	r29, bsp_section_text_start  
 	/* get start address of text section in ROM (add reloc offset) */
 	add	r30, r20, r29    
 	/* get size of startup code */
 	LA	r28, end_reloc_startup
-	LA	r31, _text_start
+	LA	r31, bsp_section_text_start
 	sub	28,r28,r31
 	/* copy startup code from ROM to RAM location */
@@ -410,6 +385,6 @@
 	add	r30, r20, r29    
 	/* get size of rest of code */
-	LA	r28, _text_start
-	LA	r31, _text_size
+	LA	r28, bsp_section_text_start
+	LA	r31, bsp_section_text_size
 	add	r28,r28,r31
 	sub	r28,r28,r29
@@ -420,9 +395,9 @@
 	 */
 	/* get start address of data section in RAM */
-	LA	r29, _data_start 
+	LA	r29, bsp_section_data_start 
 	/* get start address of data section in ROM (add reloc offset) */
 	add	r30, r20, r29    
 	/* get size of RAM image */
-	LA	r28, _data_size  
+	LA	r28, bsp_section_data_size  
 	/* copy initialized data section from ROM to RAM location */
 	bl	copy_image       
@@ -433,13 +408,30 @@
 	 * ROM/RAM startup: clear bss in SDRAM
 	 */
-	LWI	r30, _bss_start  /* get start address of bss section */
-        LWI	r29, _bss_size   /* get size of bss section */
-        bl      clr_mem          /* Clear the bss section */
+	LA	r3, bsp_section_bss_start  /* get start address of bss section */
+	LWI	r4, bsp_section_bss_size   /* get size of bss section */
+	bl	mpc83xx_zero_4          /* Clear the bss section */
 	/*
 	 * call boot_card
 	 */
-/* set stack pointer (common for RAM/ROM startup) */
-	LA	r1, _text_start  
+
+	/* Set stack pointer (common for RAM/ROM startup) */
+	LA	r1, bsp_section_text_start  
         addi    r1, r1, -0x10 /* Set up stack pointer = beginning of text section - 0x10 */     
+
+	/* Create NULL */
+	li r0, 0
+
+	/* Return address */
+	stw r0, 4(r1)
+
+	/* Back chain */
+	stw r0, 0(r1)
+
+	/* Read-only small data */
+	LA r2, _SDA2_BASE_
+
+	/* Read-write small data */
+	LA r13, _SDA_BASE_
+
 /* clear arguments and do further init. in C (common for RAM/ROM startup) */
         xor     r3, r3, r3
@@ -487,32 +479,57 @@
 	blr
 
-clr_mem:
-	mr 	r28, r29		
-	srwi	r29, r29, 2
-        mtctr   r29				/* set ctr reg */
-        
-        
-        slwi	r29, r29, 2
-        sub     r28, r28, r29			/* maybe some residual bytes */
-        xor     r29, r29, r29		
-	
-	
-clr_mem_word:
-        stswi   r29, r30, 0x04			/* store r29 (word) to r30 memory location */
-        addi    r30, r30, 0x04			/* increment r30 */
-        
-        bdnz    clr_mem_word			/* dec counter and loop */
-	
-	
-	cmpwi	r28, 0x00			/* clear mem. finished ? */
-	beq	clr_mem_end;
-        mtctr   r28				/* reload counter for residual bytes */
-clr_mem_byte:
-	stswi   r29, r30, 0x01			/* store r29 (byte) to r30 memory location  */
-	addi    r30, r30, 0x01			/* update r30 */
-        
-        bdnz    clr_mem_byte			/* dec counter and loop */
-        
-clr_mem_end:
-        blr					/* return */
+	
+/**
+ * @fn int mpc83xx_zero_4( void *dest, size_t n)
+ *
+ * @brief Zero all @a n bytes starting at @a dest with 4 byte writes.
+ *
+ * The address @a dest has to be aligned on 4 byte boundaries.  The size @a n
+ * must be evenly divisible by 4.
+ */
+GLOBAL_FUNCTION mpc83xx_zero_4
+	/* Create zero */
+	xor	r0, r0, r0
+
+	/* Set offset */
+	xor	r5, r5, r5
+
+	/* Loop counter for the first bytes up to 16 bytes */
+	rlwinm.	r9, r4, 30, 30, 31
+	beq	mpc83xx_zero_4_more
+	mtctr	r9
+
+mpc83xx_zero_4_head:
+
+	stwx	r0, r3, r5
+	addi	r5, r5, 8
+	bdnz	mpc83xx_zero_4_head
+
+mpc83xx_zero_4_more:
+
+	/* More than 16 bytes? */
+	srwi.	r9, r4, 4
+	beqlr
+	mtctr	r9
+
+	/* Set offsets */
+	addi	r6, r5, 4
+	addi	r7, r5, 8
+	addi	r8, r5, 12
+
+mpc83xx_zero_4_tail:
+
+	stwx	r0, r3, r5
+	addi	r5, r5, 16
+	stwx	r0, r3, r6
+	addi	r6, r6, 16
+	stwx	r0, r3, r7
+	addi	r7, r7, 16
+	stwx	r0, r3, r8
+	addi	r8, r8, 16
+	bdnz	mpc83xx_zero_4_tail
+	
+	/* Return */
+	blr
+
 end_reloc_startup:
Index: c/src/lib/libbsp/powerpc/gen83xx/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/startup/bspstart.c	(revision 3c6fe2e7f95f6bff53123df9377b114cadeac874)
+++ c/src/lib/libbsp/powerpc/gen83xx/startup/bspstart.c	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -1,59 +1,56 @@
-/*===============================================================*\
-| Project: RTEMS generic MPC83xx BSP                              |
-+-----------------------------------------------------------------+
-|                    Copyright (c) 2007                           |
-|                    Embedded Brains GmbH                         |
-|                    Obere Lagerstr. 30                           |
-|                    D-82178 Puchheim                             |
-|                    Germany                                      |
-|                    rtems@embedded-brains.de                     |
-+-----------------------------------------------------------------+
-| The license and distribution terms for this file may be         |
-| found in the file LICENSE in this distribution or at            |
-|                                                                 |
-| http://www.rtems.com/license/LICENSE.                           |
-|                                                                 |
-+-----------------------------------------------------------------+
-| this file contains the BSP startup code                         |
-\*===============================================================*/
+/**
+ * @file
+ *
+ * @ingroup mpc83xx
+ *
+ * @brief Source for BSP startup code.
+ */
 
 /*
- *  $Id$
- */
-
-#include <bsp.h>
+ * Copyright (c) 2008
+ * Embedded Brains GmbH
+ * Obere Lagerstr. 30
+ * D-82178 Puchheim
+ * Germany
+ * rtems@embedded-brains.de
+ *
+ * The license and distribution terms for this file may be found in the file
+ * LICENSE in this distribution or at http://www.rtems.com/license/LICENSE.
+ *
+ * $Id$
+ */
+
+#include <string.h>
 
 #include <rtems/libio.h>
 #include <rtems/libcsupport.h>
-#include <rtems/powerpc/powerpc.h>
 #include <rtems/score/thread.h>
 
-#include <rtems/bspIo.h>
-#include <libcpu/cpuIdent.h>
-#include <libcpu/spr.h>
-#include <bsp/irq.h>
-
-#include <string.h>
-
-SPR_RW(SPRG0)
-SPR_RW(SPRG1)
-
-extern unsigned long intrStackPtr;
+#include <libcpu/powerpc-utility.h>
+
+#include <bsp.h>
+#include <bsp/irq-generic.h>
+#include <bsp/ppc_exc_bspsupp.h>
+
+#ifdef HAS_UBOOT
+
+/*
+ * We want this in the data section, because the startup code clears the BSS
+ * section after the initialization of the board info.
+ */
+bd_t mpc83xx_uboot_board_info = { .bi_baudrate = 123 };
+
+/* Size in words */
+const size_t mpc83xx_uboot_board_info_size = (sizeof( bd_t) + 3) / 4;
+
+#endif /* HAS_UBOOT */
+
+/* Configuration parameters for console driver, ... */
+unsigned int BSP_bus_frequency;
+
+/* Configuration parameters for clock driver, ... */
+uint32_t bsp_clicks_per_usec;
+
 static char *BSP_heap_start, *BSP_heap_end;
-
-/*
- * constants for c_clock driver:
- * system bus frequency (for timebase etc)
- * and 
- * Time base divisior: scaling value:
- * BSP_time_base_divisor = TB ticks per millisecond/BSP_bus_frequency
- */
-unsigned int BSP_bus_frequency;
-unsigned int BSP_time_base_divisor = 4000;  /* 4 bus clicks per TB click */
-
-/*
- *  Driver configuration parameters
- */
-uint32_t   bsp_clicks_per_usec;
 
 /*
@@ -61,183 +58,147 @@
  *  Look in rtems/c/src/lib/libbsp/shared/bsplibc.c.
  */
-void bsp_libc_init( void *, uint32_t, int );
-extern void initialize_exceptions(void);
-extern void cpu_init(void);
-
-void BSP_panic(char *s)
-  {
-  printk("%s PANIC %s\n",_RTEMS_version, s);
-  /*
-   * FIXME: hang/restart system
-   */
-  __asm__ __volatile ("sc");
-  }
-
-void _BSP_Fatal_error(unsigned int v)
-  {
-  printk("%s PANIC ERROR %x\n",_RTEMS_version, v);
-  /*
-   * FIXME: hang/restart system
-   */
-  __asm__ __volatile ("sc");
-  }
-
-/*
- *  Function:   bsp_pretasking_hook
- *  Created:    95/03/10
- *
- *  Description:
- *      BSP pretasking hook.  Called just before drivers are initialized.
- *      Used to setup libc and install any BSP extensions.
- *
- *  NOTES:
- *      Must not use libc (to do io) from here, since drivers are
- *      not yet initialized.
- *
- */
-
-void
-bsp_pretasking_hook(void)
-{
-
-  /*
-   * initialize libc including the heap
-   */
-  bsp_libc_init( BSP_heap_start, 
-		 BSP_heap_end - BSP_heap_start,
-		 0);
+extern void cpu_init( void);
+
+void BSP_panic( char *s)
+{
+	rtems_interrupt_level level;
+
+	rtems_interrupt_disable( level);
+
+	printk( "%s PANIC %s\n", _RTEMS_version, s);
+
+	while (1) {
+		/* Do nothing */
+	}
+}
+
+void _BSP_Fatal_error( unsigned n)
+{
+	rtems_interrupt_level level;
+
+	rtems_interrupt_disable( level);
+
+	printk( "%s PANIC ERROR %u\n", _RTEMS_version, n);
+
+	while (1) {
+		/* Do nothing */
+	}
+}
+
+void bsp_pretasking_hook( void)
+{
+	/* Initialize libc including the heap */
+	bsp_libc_init( BSP_heap_start, BSP_heap_end - BSP_heap_start, 0);
 }
 
 void bsp_calc_mem_layout()
 {
-  /*
-   * these labels (!) are defined in the linker command file
-   * or when the linker is invoked
-   * NOTE: the information(size) is the address of the object,
-   * not the object otself
-   */
-  extern unsigned char TopRamReserved;
-  extern unsigned char _WorkspaceBase[];
-
-  /*
-   * compute the memory layout:
-   * - first unused address is Workspace start
-   * - Heap starts at end of workspace
-   * - Heap ends at end of memory - reserved memory area
-   */
-  Configuration.work_space_start = _WorkspaceBase;
-
-  BSP_heap_start = ((char *)Configuration.work_space_start +
-                    rtems_configuration_get_work_space_size());
-
-#if defined(HAS_UBOOT)
-  BSP_heap_end = (uboot_bdinfo_ptr->bi_memstart 
-		  + uboot_bdinfo_ptr->bi_memsize
-		  - (uint32_t)&TopRamReserved);
-#else
-  BSP_heap_end = (void *)(RAM_END - (uint32_t)&TopRamReserved);
+	size_t workspace_size = rtems_configuration_get_work_space_size();
+
+	/* We clear the workspace here */
+	Configuration.do_zero_of_workspace = 0;
+	/*
+	TODO
+	mpc83xx_zero_4( bsp_workspace_start, workspace_size);
+	 */
+	mpc83xx_zero_4( bsp_interrupt_stack_start, bsp_ram_end - bsp_interrupt_stack_start);
+
+	Configuration.work_space_start = bsp_workspace_start;
+
+	BSP_heap_start = (char *) Configuration.work_space_start + workspace_size;
+
+#ifdef HAS_UBOOT
+	BSP_heap_end = mpc83xx_uboot_board_info.bi_memstart + mpc83xx_uboot_board_info.bi_memsize;
+#else /* HAS_UBOOT */
+	BSP_heap_end = bsp_ram_end;
+#endif /* HAS_UBOOT */
+}
+
+void bsp_start( void)
+{
+	ppc_cpu_id_t myCpu;
+	ppc_cpu_revision_t myCpuRevision;
+
+	uint32_t interrupt_stack_start = (uint32_t) bsp_interrupt_stack_start;
+	uint32_t interrupt_stack_size = (uint32_t) bsp_interrupt_stack_size;
+
+	/*
+	 * Get CPU identification dynamically. Note that the get_ppc_cpu_type() function
+	 * store the result in global variables so that it can be used latter...
+	 */
+	myCpu = get_ppc_cpu_type();
+	myCpuRevision = get_ppc_cpu_revision();
+
+	/* Determine heap and workspace placement */
+	bsp_calc_mem_layout();
+
+	cpu_init();
+
+	/*
+	 * This is evaluated during runtime, so it should be ok to set it
+	 * before we initialize the drivers.
+	 */
+
+	/* Initialize some device driver parameters */
+
+#ifdef HAS_UBOOT
+	BSP_bus_frequency = mpc83xx_uboot_board_info.bi_busfreq;
+#else /* HAS_UBOOT */
+	BSP_bus_frequency = BSP_CLKIN_FRQ * BSP_SYSPLL_MF / BSP_SYSPLL_CKID;
+#endif /* HAS_UBOOT */
+
+	bsp_clicks_per_usec = BSP_bus_frequency / 4000000;
+
+	/*
+	 * Enable instruction and data caches. Do not force writethrough mode.
+	 */
+
+#if INSTRUCTION_CACHE_ENABLE
+	rtems_cache_enable_instruction();
 #endif
 
-}
-
-
-void bsp_start(void)
-{
-  ppc_cpu_id_t myCpu;
-  ppc_cpu_revision_t myCpuRevision;
-  register unsigned char* intrStack;
-
-  /*
-   * Get CPU identification dynamically. Note that the get_ppc_cpu_type() function
-   * store the result in global variables so that it can be used latter...
-   */
-  myCpu 	    = get_ppc_cpu_type();
-  myCpuRevision = get_ppc_cpu_revision();
-  /*
-   * determine heap and workspace placement
-   */
-  bsp_calc_mem_layout();
-
-  cpu_init();
-
-  /*
-   * Initialize some SPRG registers related to irq handling
-   */
-
-  intrStack = (((unsigned char*)&intrStackPtr) - PPC_MINIMUM_STACK_FRAME_SIZE);
-
-  _write_SPRG1((unsigned int)intrStack);
-
-  /* Signal them that this BSP has fixed PR288 - eventually, this should
-   * go away
-   */
-  _write_SPRG0(PPC_BSP_HAS_FIXED_PR288);
-
-  /*
-   * this is evaluated during runtime, so it should be ok to set it 
-   * before we initialize the drivers
-   */
-  BSP_bus_frequency   = BSP_CLKIN_FRQ * BSP_SYSPLL_MF / BSP_SYSPLL_CKID;
-  /*
-   *  initialize the device driver parameters
-   */
-  bsp_clicks_per_usec = (BSP_bus_frequency/1000000);
-
-  /*
-   * Install our own set of exception vectors
-   */
-
-  initialize_exceptions();
-
-  /*
-   * Enable instruction and data caches. Do not force writethrough mode.
-   */
-#if INSTRUCTION_CACHE_ENABLE
-  rtems_cache_enable_instruction();
+#if DATA_CACHE_ENABLE
+	rtems_cache_enable_data();
 #endif
-#if DATA_CACHE_ENABLE
-  rtems_cache_enable_data();
+
+	/* Initialize exception handler */
+	ppc_exc_initialize(
+		PPC_INTERRUPT_DISABLE_MASK_DEFAULT,
+		interrupt_stack_start,
+		interrupt_stack_size
+	);
+
+	/* Initalize interrupt support */
+	if (bsp_interrupt_initialize() != RTEMS_SUCCESSFUL) {
+		BSP_panic("Cannot intitialize interrupt support\n");
+	}
+
+#ifdef SHOW_MORE_INIT_SETTINGS
+	printk("Exit from bspstart\n");
 #endif
-
-  /*
-   *  Allocate the memory for the RTEMS Work Space.  This can come from
-   *  a variety of places: hard coded address, malloc'ed from outside
-   *  RTEMS world (e.g. simulator or primitive memory manager), or (as
-   *  typically done by stock BSPs) by subtracting the required amount
-   *  of work space from the last physical address on the CPU board.
-   */
-
-  /*
-   * Initalize RTEMS IRQ system
-   */
-  BSP_rtems_irq_mng_init(0);
-
-#ifdef SHOW_MORE_INIT_SETTINGS
-  printk("Exit from bspstart\n");
-#endif
-
-  }
-
-/*
- *
- *  _Thread_Idle_body
- *
- *  Replaces the one in c/src/exec/score/src/threadidlebody.c
- *  The MSR[POW] bit is set to put the CPU into the low power mode
- *  defined in HID0.  HID0 is set during starup in start.S.
- *
- */
-Thread _Thread_Idle_body(uint32_t ignored )
-  {
-
-  for(;;)
-    {
-
-    asm volatile("mfmsr 3; oris 3,3,4; sync; mtmsr 3; isync; ori 3,3,0; ori 3,3,0");
-
-    }
-
-  return 0;
-
-  }
-
+}
+
+/**
+ * @brief Idle thread body.
+ *
+ * Replaces the one in c/src/exec/score/src/threadidlebody.c
+ * The MSR[POW] bit is set to put the CPU into the low power mode
+ * defined in HID0.  HID0 is set during starup in start.S.
+ */
+Thread _Thread_Idle_body( uint32_t ignored)
+{
+
+	while (1) {
+		asm volatile (
+			"mfmsr 3;"
+			"oris 3, 3, 4;"
+			"sync;"
+			"mtmsr 3;"
+			"isync;"
+			"ori 3, 3, 0;"
+			"ori 3, 3, 0"
+		);
+	}
+
+	return NULL;
+}
Index: c/src/lib/libbsp/powerpc/gen83xx/startup/cpuinit.c
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/startup/cpuinit.c	(revision 3c6fe2e7f95f6bff53123df9377b114cadeac874)
+++ c/src/lib/libbsp/powerpc/gen83xx/startup/cpuinit.c	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -156,5 +156,5 @@
    */
   GET_HID0(reg);
-  reg |=  (HID0_ICFI | HID0_DCI);
+  reg = (reg & ~(HID0_ILOCK | HID0_DLOCK)) | HID0_ICFI | HID0_DCI;
   SET_HID0(reg);
   reg &= ~(HID0_ICFI | HID0_DCI);
@@ -171,8 +171,18 @@
   SET_IBAT(6,ibat.batu,ibat.batl);
   SET_IBAT(7,ibat.batu,ibat.batl);
-
-  calc_dbat_regvals(&ibat,RAM_START,RAM_SIZE,0,0,0,0,BPP_RX);
+#ifdef HAS_UBOOT
+  calc_dbat_regvals(&ibat,mpc83xx_uboot_board_info.bi_memstart,mpc83xx_uboot_board_info.bi_memsize,0,0,0,0,BPP_RX);
+#else /* HAS_UBOOT */
+  calc_dbat_regvals(&ibat,(uint32_t) bsp_ram_start,(uint32_t) bsp_ram_size,0,0,0,0,BPP_RX);
+#endif /* HAS_UBOOT */
+
   SET_IBAT(0,ibat.batu,ibat.batl);
-  calc_dbat_regvals(&ibat,ROM_START,ROM_SIZE,0,0,0,0,BPP_RX);
+
+#ifdef HAS_UBOOT
+  calc_dbat_regvals(&ibat,mpc83xx_uboot_board_info.bi_flashstart,mpc83xx_uboot_board_info.bi_flashsize,0,0,0,0,BPP_RX);
+#else /* HAS_UBOOT */
+  calc_dbat_regvals(&ibat,(uint32_t) bsp_rom_start,(uint32_t) bsp_rom_size,0,0,0,0,BPP_RX);
+#endif /* HAS_UBOOT */
+
   SET_IBAT(1,ibat.batu,ibat.batl);
 
@@ -187,11 +197,26 @@
   SET_DBAT(7,dbat.batu,dbat.batl);
 
-  calc_dbat_regvals(&dbat,RAM_START,RAM_SIZE,1,0,1,0,BPP_RW);
+#ifdef HAS_UBOOT
+  calc_dbat_regvals(&dbat,mpc83xx_uboot_board_info.bi_memstart,mpc83xx_uboot_board_info.bi_memsize,0,0,0,0,BPP_RW);
+#else /* HAS_UBOOT */
+  calc_dbat_regvals(&dbat,(uint32_t) bsp_ram_start,(uint32_t) bsp_ram_size,0,0,0,0,BPP_RW);
+#endif /* HAS_UBOOT */
+
   SET_DBAT(0,dbat.batu,dbat.batl);
 
-  calc_dbat_regvals(&dbat,ROM_START,ROM_SIZE,1,0,1,0,BPP_RX);
+#ifdef HAS_UBOOT
+  calc_dbat_regvals(&dbat,mpc83xx_uboot_board_info.bi_flashstart,mpc83xx_uboot_board_info.bi_flashsize,0,0,0,0,BPP_RX);
+#else /* HAS_UBOOT */
+  calc_dbat_regvals(&dbat,(uint32_t) bsp_rom_start,(uint32_t) bsp_rom_size,0,0,0,0,BPP_RX);
+#endif /* HAS_UBOOT */
+
   SET_DBAT(1,dbat.batu,dbat.batl);
 
-  calc_dbat_regvals(&dbat,IMMRBAR,1024*1024,1,1,1,1,BPP_RW);
+#ifdef HAS_UBOOT
+  calc_dbat_regvals(&dbat,mpc83xx_uboot_board_info.bi_immrbar,1024*1024,0,1,0,1,BPP_RW);
+#else /* HAS_UBOOT */
+  calc_dbat_regvals(&dbat,(uint32_t) IMMRBAR,1024*1024,0,1,0,1,BPP_RW);
+#endif /* HAS_UBOOT */
+
   SET_DBAT(2,dbat.batu,dbat.batl);
 
Index: c/src/lib/libbsp/powerpc/gen83xx/startup/linkcmds.base
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/startup/linkcmds.base	(revision 574fb675105b77dfe9598915207f1f32790f905f)
+++ c/src/lib/libbsp/powerpc/gen83xx/startup/linkcmds.base	(revision 574fb675105b77dfe9598915207f1f32790f905f)
@@ -0,0 +1,327 @@
+/**
+ * @file
+ *
+ * Derived from internal linker script of GNU ld (GNU Binutils) 2.18 for elf32ppc emulation.
+ */
+
+OUTPUT_FORMAT ("elf32-powerpc", "elf32-powerpc", "elf32-powerpc")
+OUTPUT_ARCH (powerpc)
+ENTRY (start)
+
+bsp_ram_start = ORIGIN (RAM);
+bsp_ram_end = ORIGIN (RAM) + LENGTH (RAM);
+bsp_ram_size = LENGTH (RAM);
+
+bsp_rom_start = ORIGIN (ROM);
+bsp_rom_end = ORIGIN (ROM) + LENGTH (ROM);
+bsp_rom_size = LENGTH (ROM);
+
+bsp_section_align = 32;
+
+SECTIONS {
+	/*
+	 * BSP: MPC83XX registers
+	 */
+	.mpc83xx_regs (NOLOAD) : { 
+		IMMRBAR = .;
+		mpc83xx_regs*(.text)
+		mpc83xx_regs*(.data)
+		mpc83xx_regs*(.bss)
+		mpc83xx_regs*(COMMON)
+	} > MPC83XX_REGS
+
+	/*
+	 * BSP: Reset configuration
+	 */
+	.resconf 0x0 : {
+		*(.resconf)
+	} > RAM
+
+	/*
+	 * BSP: Exception vectors
+	 */
+	.vectors 0x100 : {
+		*(.vectors)
+	} > RAM
+
+	/* 
+	 * BSP: The initial stack will live in this area - between the vectors
+	 * and the text section.
+	 */
+
+	.text 0x10000 : {
+		/*
+		 * BSP: Start of text section
+		 */
+		bsp_section_text_start = .;
+
+		/*
+		 * BSP: System startup entry
+		 */
+		KEEP (*(.entry))
+
+		/*
+		 * BSP: Moved into .text from .init
+		 */
+		KEEP (*(.init))
+
+		*(.text .stub .text.* .gnu.linkonce.t.*)
+		KEEP (*(.text.*personality*))
+		/* .gnu.warning sections are handled specially by elf32.em.  */
+		*(.gnu.warning)
+		*(.glink)
+		
+		/*
+		 * BSP: Special FreeBSD sysctl sections
+		 */
+		. = ALIGN (16);
+		__start_set_sysctl_set = .;
+		*(set_sysctl_*);
+		__stop_set_sysctl_set = ABSOLUTE(.);
+		*(set_domain_*);
+		*(set_pseudo_*);
+
+		/*
+		 * BSP: Moved into .text from .*
+		 */
+		*(.rodata .rodata.* .gnu.linkonce.r.*)
+		*(.rodata1)
+		*(.interp)
+		*(.note.gnu.build-id)
+		*(.hash)
+		*(.gnu.hash)
+		*(.dynsym)
+		*(.dynstr)
+		*(.gnu.version)
+		*(.gnu.version_d)
+		*(.gnu.version_r)
+		*(.eh_frame_hdr)
+
+		/*
+		 * BSP: Magic PPC stuff
+		 */
+		*(.PPC.*)
+
+		/*
+		 * BSP: Required by cpukit/score/src/threadhandler.c
+		 */
+		PROVIDE (_fini = .);
+
+		/*
+		 * BSP: Moved into .text from .fini
+		 */
+		KEEP (*(.fini))
+
+		. = ALIGN (bsp_section_align);
+
+		PROVIDE (__etext = .);
+		PROVIDE (_etext = .);
+		PROVIDE (etext = .);
+	} > RAM
+
+	.sdata2 : {
+		PROVIDE (_SDA2_BASE_ = 32768);
+
+		*(.sdata2 .sdata2.* .gnu.linkonce.s2.*)
+
+		. = ALIGN (bsp_section_align);
+	} > RAM
+
+	.sbss2 : {
+		*(.sbss2 .sbss2.* .gnu.linkonce.sb2.*)
+
+		. = ALIGN (bsp_section_align);
+
+		/*
+		 * BSP: End and size of text section
+		 */
+		bsp_section_text_end = .;
+		bsp_section_text_size = bsp_section_text_end - bsp_section_text_start;
+	} > RAM
+
+	.data : {
+		/*
+		 * BSP: Start of data section
+		 */
+		bsp_section_data_start = .;
+
+		/*
+		 * BSP: Moved into .data from .ctors
+		 */
+		/* gcc uses crtbegin.o to find the start of
+		   the constructors, so we make sure it is
+		   first.  Because this is a wildcard, it
+		   doesn't matter if the user does not
+		   actually link against crtbegin.o; the
+		   linker won't look for a file to match a
+		   wildcard.  The wildcard also means that it
+		   doesn't matter which directory crtbegin.o
+		   is in.  */
+		KEEP (*crtbegin.o(.ctors))
+		KEEP (*crtbegin?.o(.ctors))
+		/* We don't want to include the .ctor section from
+		   the crtend.o file until after the sorted ctors.
+		   The .ctor section from the crtend file contains the
+		   end of ctors marker and it must be last */
+		KEEP (*(EXCLUDE_FILE (*crtend.o *crtend?.o ) .ctors))
+		KEEP (*(SORT(.ctors.*)))
+		KEEP (*(.ctors))
+
+		/*
+		 * BSP: Moved into .data from .dtors
+		 */
+		KEEP (*crtbegin.o(.dtors))
+		KEEP (*crtbegin?.o(.dtors))
+		KEEP (*(EXCLUDE_FILE (*crtend.o *crtend?.o ) .dtors))
+		KEEP (*(SORT(.dtors.*)))
+		KEEP (*(.dtors))
+
+		/*
+		 * BSP: Moved into .data from .*
+		 */
+		*(.tdata .tdata.* .gnu.linkonce.td.*)
+		*(.tbss .tbss.* .gnu.linkonce.tb.*) *(.tcommon)
+		*(.data1)
+		KEEP (*(.eh_frame))
+		*(.gcc_except_table .gcc_except_table.*)
+		KEEP (*(.jcr))
+		*(.data.rel.ro.local* .gnu.linkonce.d.rel.ro.local.*) *(.data.rel.ro* .gnu.linkonce.d.rel.ro.*)
+		*(.fixup)
+		*(.got1)
+		*(.got2)
+		*(.dynamic)
+		*(.got)
+		*(.plt)
+		PROVIDE_HIDDEN (__preinit_array_start = .);
+		KEEP (*(.preinit_array))
+		PROVIDE_HIDDEN (__preinit_array_end = .);
+		PROVIDE_HIDDEN (__init_array_start = .);
+		KEEP (*(SORT(.init_array.*)))
+		KEEP (*(.init_array))
+		PROVIDE_HIDDEN (__init_array_end = .);
+		PROVIDE_HIDDEN (__fini_array_start = .);
+		KEEP (*(.fini_array))
+		KEEP (*(SORT(.fini_array.*)))
+		PROVIDE_HIDDEN (__fini_array_end = .);
+
+		*(.data .data.* .gnu.linkonce.d.*)
+		KEEP (*(.gnu.linkonce.d.*personality*))
+		SORT(CONSTRUCTORS)
+
+		. = ALIGN (bsp_section_align);
+	} > RAM
+
+	.sdata : {
+		PROVIDE (_SDA_BASE_ = 32768);
+		*(.sdata .sdata.* .gnu.linkonce.s.*)
+
+		. = ALIGN (bsp_section_align);
+
+		_edata = .;
+		PROVIDE (edata = .);
+
+		/*
+		 * BSP: End and size of data section
+		 */
+		bsp_section_data_end = .;
+		bsp_section_data_size = bsp_section_data_end - bsp_section_data_start;
+	} > RAM
+
+	.sbss : {
+		/*
+		 * BSP: Start of bss section
+		 */
+		bsp_section_bss_start = .;
+
+		__bss_start = .;
+
+		PROVIDE (__sbss_start = .); PROVIDE (___sbss_start = .);
+		*(.scommon)
+		*(.dynsbss)
+		*(.sbss .sbss.* .gnu.linkonce.sb.*)
+		PROVIDE (__sbss_end = .); PROVIDE (___sbss_end = .);
+
+		. = ALIGN (bsp_section_align);
+	} > RAM
+
+	.bss : {
+		*(COMMON)
+		*(.dynbss)
+		*(.bss .bss.* .gnu.linkonce.b.*)
+
+		. = ALIGN (bsp_section_align);
+
+		__end = .;
+		_end = .;
+		PROVIDE (end = .);
+
+		/*
+		 * BSP: End and size of bss section
+		 */
+		bsp_section_bss_end = .;
+		bsp_section_bss_size = bsp_section_bss_end - bsp_section_bss_start;
+	} > RAM
+
+	/*
+	 * BSP: Interrupt stack
+	 */
+	bsp_interrupt_stack_start = .;
+	bsp_interrupt_stack_end = bsp_interrupt_stack_start + 32k;
+	bsp_interrupt_stack_size = bsp_interrupt_stack_end - bsp_interrupt_stack_start;
+	bsp_interrupt_stack_pointer = bsp_interrupt_stack_end - 16;
+	. = bsp_interrupt_stack_end;
+
+	/*
+	 * BSP: Workspace start
+	 */
+	bsp_workspace_start = .;
+	
+	/* Stabs debugging sections.  */
+	.stab          0 : { *(.stab) }
+	.stabstr       0 : { *(.stabstr) }
+	.stab.excl     0 : { *(.stab.excl) }
+	.stab.exclstr  0 : { *(.stab.exclstr) }
+	.stab.index    0 : { *(.stab.index) }
+	.stab.indexstr 0 : { *(.stab.indexstr) }
+	.comment       0 : { *(.comment) }
+	/* DWARF debug sections.
+	   Symbols in the DWARF debugging sections are relative to the beginning
+	   of the section so we begin them at 0.  */
+	/* DWARF 1 */
+	.debug          0 : { *(.debug) }
+	.line           0 : { *(.line) }
+	/* GNU DWARF 1 extensions */
+	.debug_srcinfo  0 : { *(.debug_srcinfo) }
+	.debug_sfnames  0 : { *(.debug_sfnames) }
+	/* DWARF 1.1 and DWARF 2 */
+	.debug_aranges  0 : { *(.debug_aranges) }
+	.debug_pubnames 0 : { *(.debug_pubnames) }
+	/* DWARF 2 */
+	.debug_info     0 : { *(.debug_info .gnu.linkonce.wi.*) }
+	.debug_abbrev   0 : { *(.debug_abbrev) }
+	.debug_line     0 : { *(.debug_line) }
+	.debug_frame    0 : { *(.debug_frame) }
+	.debug_str      0 : { *(.debug_str) }
+	.debug_loc      0 : { *(.debug_loc) }
+	.debug_macinfo  0 : { *(.debug_macinfo) }
+	/* SGI/MIPS DWARF 2 extensions */
+	.debug_weaknames 0 : { *(.debug_weaknames) }
+	.debug_funcnames 0 : { *(.debug_funcnames) }
+	.debug_typenames 0 : { *(.debug_typenames) }
+	.debug_varnames  0 : { *(.debug_varnames) }
+	/* DWARF 3 */
+	.debug_pubtypes 0 : { *(.debug_pubtypes) }
+	.debug_ranges   0 : { *(.debug_ranges) }
+	.gnu.attributes 0 : { KEEP (*(.gnu.attributes)) }
+
+	/DISCARD/ : {
+		*(.note.GNU-stack) *(.gnu_debuglink)
+	}
+
+	/*
+	 * BSP: Catch all unknown sections
+	 */
+	.nirvana : {
+		*(*)
+	} > NIRVANA
+}
